-------------------------------------------------
-- Bullet Bill Cannon + Bullet Bill -------------
-- A Part of Blast from the Past Pack by mat5b --
-------------------------------------------------

bb={}
bb.img=loadgfx("weapons/bulletbill.png")
bb.cannonimg=loadgfx("weapons/bulletbill_cannon.png")
bb.snd=loadsfx("bulletbill.ogg")
setmidhandle(bb.cannonimg)
bb.cannon={}
bb.cannon.bullet={}
bb.id=addweapon("bb.cannon","Bullet Bill Cannon",bb.cannonimg,1,0)
bb.cannon.bullet.id=addprojectile("bb.cannon.bullet")
bb.cannon.cannon={}

function bb.cannon.draw()
	if getplayeraction(0)==0 and weapon_shots<=0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(1,1)
		setrotation(0)
		drawimage(bb.cannonimg,getplayerx(0)+getplayerdirection(0)*16,getplayery(0)-6)
	end
end

function bb.cannon.attack(attack)
	if (weapon_shots<=0) then
		if attack==1 then
			useweapon(0)
			playercontrol(0)
			playsound(bb.snd,0)
			--weapon_shots=weapon_shots+1
			id=createprojectile(bb.cannon.bullet.id)
			projectiles[id]={}
			projectiles[id].ignore=playercurrent()
			projectiles[id].x=getplayerx(0)+getplayerdirection(0)*15
			projectiles[id].y=getplayery(0)-26
			projectiles[id].sx=getplayerdirection(0)*4
			projectiles[id].sy=0
			projectiles[id].timer=250
			endturn()
		end
	end
end

function bb.cannon.bullet.draw(id)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setrotation(0)
	if getplayerdirection(0)==1 then
		setscale(-1,1)
	else
		setscale(1,1)
	end
	drawimage(bb.img,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function bb.cannon.bullet.update(id)
	local f=getframe()
	if f%6==0 then
		particle(p_smoke,projectiles[id].x-(getplayerdirection(0)*24),projectiles[id].y+12)
		particlespeed(math.random(-1,1)*0.1,math.random(-3,0)*0.1)
		particlefadealpha(0.01)
	end
	projectiles[id].x=projectiles[id].x+projectiles[id].sx
	projectiles[id].timer=projectiles[id].timer-1
	if projectiles[id].timer<=0 then
		arealdamage(projectiles[id].x,projectiles[id].y,125,65)
		terrainexplosion(projectiles[id].x,projectiles[id].y,55,1)
		grey=math.random(0,40)
		if math.random(0,1)==1 then
			terrainalphaimage(gfx_crater150,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		else
			terrainalphaimage(gfx_crater175,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		end
		stopchannel(0)
		freeprojectile(id)
	end
	if collision(col10x10,projectiles[id].x,projectiles[id].y+8,0,1,0,projectiles[id].ignore,bb.cannon.cannon.id)==1 then     -- Welcome. Prepare your brains and internet skills, because it's about to get tricky here.
		playerdamage(playercollision(),50)																					  -- Look for clues for the password. 
		terrainexplosion(projectiles[id].x,projectiles[id].y,30,1)															  -- You should know that they exist to help you, not to screw you over.
		grey=math.random(0,40)																								  -- Start here: Script using the value frk1, line (#as.english * 10) + #hrpg.furn.prices - hrpg.bldgx[27][2]
		if math.random(0,1)==1 then																							  -- Or here (both contain a clue): Script with a single minigame, line (#npcrot / (hrpg.furn.types[3] * 10))
			terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)		  -- The next clues' locations are here: Script with allies, line (#npchealth / 10)
		else
			terrainalphaimage(gfx_crater75,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
		end
		scroll(projectiles[id].x,projectiles[id].y)
		stopchannel(0)
		freeprojectile(id)
	end
	scroll(projectiles[id].x,projectiles[id].y)
end